;This handles all the special moves for each of the players


;this table points to instructions for special for each character
;to continue a special move, 2 is added to pointer
specialtable:
	.dw 960, 864, 1056, 1056, 1056, 960
	.dw 1248, 960, 1056, 864, 864, 1056
	.dw 960, 960, 960, 1056, 1056

dospecialstuff:
	ld a, (char1num)
	add a, a					;multiply character number by 2
	ld l, a
	ld h, 0
	ld de, specialtable			;add it to the special table
	add hl, de
	ld e, (hl)
	inc hl
	ld d, (hl)
	ex de, hl
	ld a, (char1special)
	or a
	jr z, jumptohl2				;if the special isn't turned on do so.
	inc hl
	inc hl						;else skip the beginning assignment
jumptohl:
	ld de, (char1pos)			;add it to char data pos (special move instructions in the variable)
	add hl, de
	ld a, l
	ld (jhl+1), a				;load memory location that the jump
	ld a, h						;jumps to.
	ld (jhl+2), a
	ld a, (char1special)
jhl
	jp 0
jumptohl2:
	ld a, (char1jump)			;specials can NEVER start be mid-jump
	or a
	ret nz
	ld a, (char1sphealth)
	cp 20
	ret c
	sub 20
	ld (char1sphealth), a
	jr jumptohl

updatesphealth3:
	ld a, (counter)
	and %00000111
	ret nz
	ld hl, char3sphealth
	inc (hl)
	ld a, (hl)
	cp 45
	ret nz
	dec (hl)
	ret

drawsphealth:
	ld a, (counter)
	and %00000111
	jr nz, noback2
	ld hl, char1sphealth
	inc (hl)
	ld a, (hl)
	cp 45
	jr nz, noback1
	dec (hl)
noback1
	ld hl, char2sphealth
	inc (hl)
	ld a, (hl)
	cp 45
	jr nz, noback2
	dec (hl)
noback2
	ld c, %10000000
	ld hl, $a002
	ld de, $a402
	ld a, (char1sphealth)
	inc a		;if 0 that's bad
	ld b, a
dch1loop
	ld a, c
	or (hl)
	ld (hl), a
	ex de, hl
	ld a, c
	or (hl)
	ld (hl), a
	ex de, hl
	rrc c
	jr nc, dontadd1
	inc hl
	inc de
dontadd1
	djnz dch1loop
	ld c, %00000001
	ld hl, $a00d
	ld de, $a40d
	ld a, (char2sphealth)
	inc a	; if 0 that's bad
	ld b, a		
dch2loop
	ld a, c
	or (hl)
	ld (hl), a
	ex de, hl
	ld a, c
	or (hl)
	ld (hl), a
	ex de, hl
	rlc c
	jr nc, dontsub1
	dec hl
	dec de
dontsub1
	djnz dch2loop
	ld hl, $a002			;creates dark grey of 'blending' special status bar
	ld de, $a012
	ld bc, 12
	ldir
	ld hl, $a402			;creates light grey
	ld de, $a422
	ld bc, 12
	ldir
	ret

teamupmode:
	ld a, (outnumbermode)
	or a
	jp z, modenotavailable
	ld a, 1
	ld (rounds), a							;1/1 rounds and easy difficulty
	ld (difficulty), a
	call characterselect					;select a character
	ld (char1num), a
teamupmodeloop:
	ld a, 3
	ld (calcnum), a							;set calc num to 3 (indicates team up mode)
	ld a, r									;get some random number
dudeloopforbetterrandomnumbers
	add a, 157								;add 157 for kicks
	and %00001111
	cp NUM_CHARS							;compare to highest number of possible characters
	jr nc, dudeloopforbetterrandomnumbers	;if higher, try agian
	ld e, a
	ld d, 0
	ld hl, availablechars					;add offset to find out if character is available or not
	add hl, de
	ld a, (hl)								;if not, try agian
	or a
	jr z, dudeloopforbetterrandomnumbers
	ld a, e									;else this is truly a random character!
	ld (char2num), a
	xor a
	ld (speed), a
	call playfight							;call fighting routine
	or a									;if we died, back to menu
	ret z
	ld hl, match							;increase the match number
	inc (hl)
	jr teamupmodeloop						;else loop agian

.end
