;ROUTINE: LOAD STRING 2					;By: Thomas Williamson
;size: 30 bytes (not including old load string routine (for code compatibility))
;input: hl contains pointer to var. data
;destroys: ? probably everything
;output: requested file loaded to $8000+de (ix bytes) on ram page 1
;if the variable isn't there, things get screwy (but not chaotic, as in no crashes)
loadstring:
	ld ix, $2000
	ld de, $0100

loadstring2
	push ix
	push de
	rst 20h
	rst 10h
	ld a,b
	ex de,hl
	call _ahl_plus_2_pg3
	call _set_abs_src_addr
	ld a,1
	pop hl
	call _set_abs_dest_addr
	xor a
	pop hl
	call _set_mm_num_bytes
	call _mm_ldir
	jp _ram_page_1

;ROUTINE: DRAW SPR 16*24				;By: Thomas Williamson
;size: 68 bytes, avg. 8700 cycles
;input: hl = start of sprite data, de=screen pos.
;destroys: everything
;output: screen display (orred to screen)
drawgameguy:
	push hl
	ld h, $00				;code borrowed from findpixel
	ld a,e
	add a,a
	add a,a
	ld l,a
	ld a,d
	rra
	add hl,hl
	rra
	add hl,hl
	rra
	or l
	ld l,a
	ld a, (bufferman)
	ld b, a
	ld a, h
	add a, b
	ld h, a
	ld a,d
	and %00000111
	pop ix
	ld b, 24
	ld c, a
ds21lp:
	push bc
	ld e, (ix + 0)
	ld d, (ix + 1)
	ld a, c
	ld c, 0
	or a
	jr z, skiprotate
	ld b, a
ds21lp2:
	rr e
	rr d
	rr c
	djnz ds21lp2
skiprotate:
	ld a, (hl)
	or e
	ld (hl), a
	inc hl
	ld a, (hl)
	or d
	ld (hl), a
	inc hl
	ld a, (hl)
	or c
	ld (hl), a
	inc ix
	inc ix
	ld bc, 14
	add hl, bc
	pop bc
	djnz ds21lp
	ret
bufferman:
	.db 0

;ROUTINE: FLIP SPRITE					By: Thomas Williamson
;size: 57 bytes
;input: hl at 24*16 sprite location
;destroys: everything
;output: sprite is flipped horizontally
flipsprite:
	ld b, 48
	ld d, %10000000
	ld e, %00000001
fspriteloop:
	push bc
	push hl
	ld c, (hl)
	inc hl
	ld h, (hl)
	ld b, 8
	ld l, 0
fmeloop:
	ld a, c
	and d
	jr z, nobitflip
	ld a, l
	or e
	ld l, a
nobitflip
	rrc d
	rlc e
	djnz fmeloop
	ld c, h
	ld h, l
	ld l, b
	ld b, 8
fmeloop2:
	ld a, c
	and d
	jr z, nobitflip2
	ld a, l
	or e
	ld l, a
nobitflip2
	rrc d
	rlc e
	djnz fmeloop2
	push hl
	pop bc
	pop hl
	ld (hl), c
	inc hl
	ld (hl), b
	inc hl
	pop bc
	djnz fspriteloop
	ret

;clear buffer
clearbuffer:
	ld hl, $a000
	ld de, $a001
	ld (hl), l
	ld bc, 2047
	ldir
	ret

;clears the buffer by erasing sprites indicated on the gfx stack...a HECK of a lot
;faster than clearing the entire thing
clearbufferB
	ld a, (gfxstacknum)	
	ld b, a
	ld hl, gfxstack
cbufferlp
	push bc
	ld e, (hl)
	inc hl
	ld d, (hl)
	inc hl
	push hl
	ex de, hl
	push hl
	ld bc, $a000
	add hl, bc
	ld de, 14
	call clearbuff
	pop hl
	ld bc, $a400
	add hl, bc
	call clearbuff
	pop hl
	pop bc
	djnz cbufferlp
	ld hl, gfxstacknum
	ld (hl), b
	ld hl, Backdrop
	ld de, $a7c2
	ld bc, 62
	ldir
	ld hl, $a002
	ld de, $a003
	ld bc, 27
	ld (hl), 0
	ldir
	ld hl, $a402
	ld de, $a403
	ld bc, 43
	ld (hl), 0
	ldir
	ret

clearbuff
	ld b, 24
cbufferlp2:
	ld (hl), 0
	inc hl
	ld (hl), 0
	inc hl
	ld (hl), 0
	add hl, de
	djnz cbufferlp2
	ret

;Copy Screen
copyscreen
	ld hl, $a002
	ld de, $fc02
	call cscr
	ld hl, $a402
	ld de, $ca02
cscr				;try to get this lower than 116 cycles (technically alot more, yadayadayada...)
	ld a, 64
cscr1
	ld bc, 12
	ldir
	inc hl
	inc hl
	inc hl
	inc hl
	inc de
	inc de
	inc de
	inc de
	dec a
	or a
	jr nz, cscr1
	ret

;Old Routines:
keyloop:
	ld l, 0
keyloopb:
	push bc
	ld b, 10
keyloop2:
	ld e, 128
 	ld a,%1111110
	out (1),a
 	nop
 	in a,(1)
 	rra
 	call nc,ldkey
	rrc e
 	rra
 	call nc,ldkey
	rrc e
 	rra
 	call nc,ldkey
	rrc e
 	rra
 	call nc,ldkey
	rrc e
	ld a,%00111111
	out (1), a
	nop
	in a, (1)
	and %01000000
	call z, ldkey
	rrc e
	in a, (1)
	ld h, a
	and %00100000
	call z, ldkey
	rrc e
	ld a, %01011111
	out (1), a
	nop
	in a, (1)
	push af
	and %10000000
	call z, ldkey
	rrc e
	pop af
	and %01000000
	call z, ldkey
	djnz keyloop2
	pop bc
	djnz keyloopb
	ld a, l
	ld (keyvar), a
	ret
ldkey:
	ld d, a
	ld a, l
	or e
	ld l, a
	ld a, d
	ret
; keys:
; 0=nothing
; 8=down
; 7=left
; 6=right
; 5=up
; 4=exit
; 3=2nd
; 2=alpha			;this bit-1 turned on
; 1=graph

waitkey:
	ld b, 1
	call keyloop
	or a
	jr nz, waitkey
	ret

pause:
	call waitkey
pause3:
	ld b, 1
	call keyloop
	and %00000100
	jr z, pause3
	jp waitkey

drawstring:
	push de
	ld (_pencol), de
	call _vputs
	pop de
	ret

drawcharname:
	ld hl, charnames
	call stringheart
	inc hl
	inc hl
	jp drawstring

drawseriesthing:
	call stringheart
	jp drawstring

getcharvar:
	ld hl, charnames
	call stringheart
	dec hl
	ld ix, 2048
	jp loadstring2

stringheart
	inc a
	ld b, a
ditemloop
	push bc
	ld b, 1
	xor a
	cpir
	pop bc
	djnz ditemloop
	ret

clearselection:
	xor a
	ld hl, $fc60
	ld de, $fc61
	call clear800
	ld hl, $ca60
	ld de, $ca61
clear800
	ld (hl), a
	ld bc, 800
	ldir
	ret

;You may find this similar to the Mardell/SCabby displayHL routine from ACZ
;I made it though, then saw their routine :) seriously! Anyway
;the old routine was the dirtiest, $%#@%$@ routine...(scowl)
drawnumber:
	ld a, 20
	add a, c
	ld c, a
	ld de, numberbuffer+5   ;buffer to store ASCII in
PNStl1:
	call _divHLby10   ;call function to convert from number to digit
	dec de
	add a, '0'          ;convert digit to ASCII-number for digit
	ld (de), a          ;store in ASCII-buffer
	dec c
	dec c			;faster than the above change of c
	dec c
	dec c
	ld a, l
	or h
	jr nz, PNStl1
	ld (_penCol), bc
	ex de, hl
	jp _vputs   	;print it to screen

numberbuffer:
	.db  0,0,0,0,0,0

hline:
	add a, a
	add a, a
	ld l, a
	ld h, $3f
	add hl, hl
	add hl, hl
	ld b, 32
hlineloop:
	ld a, r
	ld (hl), a
	inc hl
	djnz hlineloop
	ret

drawgamespr:
	dec e
	push hl
	push de
;the following finds and stores the offset of where the sprite is stored
;....so it can be erased quickly
	ld h, $00				;code borrowed from findpixel
	ld a,e
	add a,a
	add a,a
	ld l,a
	ld a,d
	rra
	add hl,hl
	rra
	add hl,hl
	rra
	or l
	ld l,a
	push hl
	ld hl, gfxstacknum			;get the number of gfx items on the screen
	ld a, (hl)					;load a with number
	inc (hl)					;add 1 to it (not in a)
	pop hl
	add a, a					;multiply a by 2
	ld de, gfxstack				;normally DONT do this!
	add a, e					;add it to the lower byte of gfxstack
	ld e, a						;and ASSUME that the argument is fine..(the sweat is rolling)
	ex de, hl
	ld (hl), e
	inc hl
	ld (hl), d

	pop de
	pop hl
	ld a, $a0
	ld (bufferman), a
	call drawgameguy
	inc h
	inc h
	inc h
	inc h
drawpage2:
	or a
	ld de, 384
	sbc hl, de
	ld b, 24
	jp ds21lp

drawspr2416:
	ld a, $fc
	ld (bufferman), a
	call drawgameguy
	ld a, h
	sub $32
	ld h, a
	jr drawpage2

cleargamedata:
	ld hl, GAMEDATA
	ld de, GAMEDATA+1
	ld bc, 512
	ld (hl), c
	ldir
	ret

;Thank Jimmy Mardell and Pascal Bouron for these! I 'borrowed' them from Ztetris (like everyone else)
ReceiveByte:
	xor a
	ld (lcounter), a
 ld 	 e,1			 ; for the OR
 ld 	 c,a			 ; byte receive
 ld 	 b,8			 ; counter
 ld 	 a,$C0
 out	 (7),a
rb_w_Start:
 in 	 a,(7)
 and 3
 cp  3
 jr 	 nz,rb_get_bit
	call TEST_ON
 jr 	 rb_w_Start
rb_get_bit:
 cp 	 2
 jr 	 z,rb_receive_zero
 ld 	 a,c
 or 	 e
 ld 	 c,a
 ld 	 a,$D4
 out	 (7),a
 jr 	 rb_waitStop
rb_receive_zero:
 ld 	 a,$E8
 out	 (7),a
rb_waitStop:
	call Test_ON
 in 	 a,(7)
 and	 3
 jr 	 z,rb_waitStop
 ld 	 a,$c0
 out	 (7),a
 rl 	 e
 djnz 	 rb_w_Start
 ld 	 a,c
 ret

SendByte:
 ld		 c, a
 ld 	 b,8
 ld 	 a,$C0
 out	 (7),a
w_setport3:
 in 	 a,(7)
 and 3
 cp  3
 jr 	 z,calc_bit
 jr 	 w_setport3
calc_bit:
 ld 	 a,c
 and	 1
 jr 	 z,send_one
send_zero:
 ld 	 a,$E8
 out	 (7),A
 jr 	 wait_setport
send_one:
 ld 	 a,$D4
 out	 (7),A
wait_setport:
 in 	 a,(7)
 and	 3
 jr 	 nz,wait_setport
 ld 	 a,$C0
 out	 (7),A
 srl c
 djnz w_setport3
 ret

Test_ON:
 ld a,(lcounter)
 inc a
 ld (lcounter),a
 cp 255
 ret nz
 pop hl  ;Back to the place you were before.	Gotta love it!
 xor a
 ret

lcounter:
	.db 0

.end
